/*######   Copyright (c) 2013-2015 Ufasoft  http://ufasoft.com  mailto:support@ufasoft.com,  Sergey Pavlov  mailto:dev@ufasoft.com ####
#                                                                                                                                     #
# 		See LICENSE for licensing information                                                                                         #
#####################################################################################################################################*/

#pragma once

namespace Coin {

struct FreqData {
	double ErrorRate, MaxErrorRate, ErrorWeight;
	double ErrorCount;

	FreqData()
		:	ErrorRate(0)
		,	MaxErrorRate(0)
		,	ErrorWeight(0)
		,	ErrorCount(0)
	{}
};

class DynClockDevice {
public:
	vector<FreqData> FreqDatas;
	int m_clockUnits, m_maxClockUnits, m_defaultClockUnits;

	virtual ~DynClockDevice() {}

	void Update(double errPortion);

	virtual int GetClock() { return m_clockUnits; }
	virtual void SetClock(int mhz) { m_clockUnits = mhz; }
	
protected:

	virtual void ChangeFrequency(int units) =0;

private:

};



} // Coin::

