/*######   Copyright (c) 2013-2015 Ufasoft  http://ufasoft.com  mailto:support@ufasoft.com,  Sergey Pavlov  mailto:dev@ufasoft.com ####
#                                                                                                                                     #
# 		See LICENSE for licensing information                                                                                         #
#####################################################################################################################################*/

#pragma once

#include "miner.h"

namespace Coin {

class StopException : public Exception {
};

class SerialDeviceThread : public WorkerThreadBase {
	typedef WorkerThreadBase base;
public:
	String m_devpath;
	AutoResetEvent m_evDetected, m_evStartMining;
	unsigned MsTimeout;
	CBool Detected;
	CBool AutoStart;

	SerialDeviceThread(BitcoinMiner& miner, thread_group *tr)
		:	base(miner, tr)
		,	m_file(0)
		,	MsTimeout(1000)
	{
	}

	void Write(const ConstBuf& cbuf);
	Blob Command(const ConstBuf cmd, size_t replySize);
	void Stop() override;
protected:
	FILE *m_file;

	void CloseFile() {
		if (FILE *file = exchange(m_file, nullptr))
			fclose(file);
	}

	virtual void CommunicateDevice() =0;
	void Execute() override;
};




} // Coin::

